<?php
/**
 * @package BakerySoftware.com
 * @version 1.0.5
 */
/*
Plugin Name: BakerySoftware
Plugin URI: https://bakerysoftware.com/en/WordPress.php
Version: 1.0.5
Description: This links Wordpress and WooCommerce with the BakerySoftware.com bakery software.
Author: BakerySoftware.com
Author URI: https://bakerysoftware.com
*/

/*
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

It is in line with: DIRECTIVE 2009/24/EC OF THE EUROPEAN 
PARLIAMENT AND OF THE COUNCIL of 23 April 2009 on the legal 
protection of computer programs, which stipulates that the 
Berne Convention for the Protection of Literary and Artistic 
Works applies. So accept it as a work of art and nothing else. 

Copyright BakerySoftware.com
*/

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

error_reporting(E_ALL);
ini_set("display_errors", 1);

// bs stands for BakerySoftware
$bs_telephone_id_code = get_option('bs_telephone_id_code');
$bs_enlarge_bs_page_by_factor = get_option('bs_enlarge_bs_page_by_factor');
$bs_show_bs_header_and_footer = get_option('bs_show_bs_header_and_footer');
$bs_show_the_nutritional_values_on_the_right = get_option('bs_show_the_nutritional_values_on_the_right');
$bs_show_a_photo_on_the_food_info_page = get_option('bs_show_a_photo_on_the_food_info_page');
$bs_use_http_and_not_https = get_option('bs_use_http_and_not_https');
$bs_iframe_width = get_option('bs_iframe_width');
$bs_iframe_height = get_option('bs_iframe_height');
$bs_iframe_border_thickness_px = get_option('bs_iframe_border_thickness_px');
$bs_iframe_border_color = get_option('bs_iframe_border_color');
$bs_iframe_border_style = get_option('bs_iframe_border_style');
$bs_Location_of_the_product_page_on_the_WordPress_website = get_option('bs_location_of_the_product_page', null); //'/?page_id=2';
$bs_Text_for_the_link_to_the_product_page = get_option('bs_text_for_the_link_to_the_product_page', 'Allergens &amp; extra info'); //'Allergenen & extra info';
$bs_Text_Order_Only_Via_The_Shop = get_option('bs_text_order_only_via_the_shop', 'Only via the shop');//'Alleen via de winkel';

$CSV_File = WP_PLUGIN_DIR.'/bakery_software/WooCommerce.csv';
global $CSV_File;
$log = '';
global $log;

function bakery_software_return( $atts, $tag ) {
// Init variables
  global $bs_telephone_id_code;
  global $bs_enlarge_bs_page_by_factor;
  global $bs_show_bs_header_and_footer;
  global $bs_show_the_nutritional_values_on_the_right;
  global $bs_show_a_photo_on_the_food_info_page;
  global $bs_use_http_and_not_https;
  global $bs_iframe_width;
  global $bs_iframe_height;
  global $bs_iframe_border_thickness_px;
  global $bs_iframe_border_color;
  global $bs_iframe_border_style;
	$a = shortcode_atts( array(
		'telephone_id_code' => $bs_telephone_id_code, // required
		'bs_page_name' => null, // required
		'bs_sku' => null, // required if product page
		'enlarge_bs_page_by_factor' => $bs_enlarge_bs_page_by_factor,
		'show_bs_header_and_footer' => $bs_show_bs_header_and_footer,
		'show_the_nutritional_values_on_the_right' => $bs_show_the_nutritional_values_on_the_right,
		'show_a_photo_on_the_food_info_page' => $bs_show_a_photo_on_the_food_info_page,
		'use_http_and_not_https' => $bs_use_http_and_not_https,
		'iframe_title' => 'Allergy search page and our ingredient declarations and nutritional values calculated with our bakery software from BakerySoftware.com.', // required, do not set to null
		'iframe_width' => $bs_iframe_width,
		'iframe_height' => $bs_iframe_height,
		'iframe_border_thickness_px' => $bs_iframe_border_thickness_px,
		'iframe_border_color' => $bs_iframe_border_color,
		'iframe_border_style' => $bs_iframe_border_style), $atts );
  if ( (is_null($a['bs_sku'])) and (isset($_GET['bs_sku'])) )
	  $a['bs_sku'] = $_GET['bs_sku'];
// Look for errors	
	$e = ''; // List of error messages
	if ( is_null($a['telephone_id_code']) )
		$e .= '- "telephone_id_code" is required. This is the baker'."'".'s international telephone number without the "+" (no spaces).<br />';
	if ( is_null($a['bs_page_name']) )
		$e .= '- "bs_page_name" is required. Possible: "index", "assortment", "allergy", "info", "product".<br />';
	else if (( $a['bs_page_name'] == 'product') and (is_null($a['bs_sku'])))
		$e .= '- "bs_sku" is required. This is the number after the "i=" in the bs URL.<br />';
// Create output	
	if ($e == '') // If no errors found
		{
    if ($a['use_http_and_not_https'] == 1) // If the website is http, use 1
  	  $s = '<iframe src="http://geert.com/bakerysoftware.com/';
  	else	
  	  $s = '<iframe src="https://bakerysoftware.com/';
    $s .= $a['telephone_id_code'].'/'.$a['bs_page_name'].'.php?x=';
		if ($a['show_bs_header_and_footer'] == '1')
		  $s .= '0';
		else	
		  $s .= '1';
		if ($a['show_the_nutritional_values_on_the_right'] == '1')
		  $s .= '&t=1';
		else	
		  $s .= '&t=0';
		if ($a['show_a_photo_on_the_food_info_page'] == '1')
		  $s .= '&f=1';
		else	
		  $s .= '&f=0';
		$s .= '&e='.$a['enlarge_bs_page_by_factor'];
		if ($a['bs_page_name'] == 'product')
  		$s .= '&i='.$a['bs_sku'];
 	  $s .= '" title="'.$a['iframe_title'].'"';
    $s .= ' width='.$a['iframe_width'].' height='.$a['iframe_height'].
  		' style="border:'.$a['iframe_border_thickness_px'].'px '.$a['iframe_border_style'].' '.$a['iframe_border_color'].';"></iframe>';
  	}
	else // If errors found
	  $s = 'Error in shortcode "'.$tag.'": <br />'.$e.
		  '<br />Example:<br />[BakerySoftware telephone_id_code="31777777777" bs_page_name="allergy" iframe_title="Allergy search page"]<br /><br />Current: '.
			var_export($a, true);
	return $s;
}

add_shortcode( 'BakerySoftware', 'bakery_software_return' );

// Product displayed prices - https://stackoverflow.com/questions/49238441/replace-product-zero-displayed-price-with-a-custom-text-in-woocommerce-3
add_filter( 'woocommerce_get_price_html', 'free_price_custom_label', 20, 2 );
function free_price_custom_label( $price, $product ) {
  global $bs_Location_of_the_product_page_on_the_WordPress_website;
  global $bs_Text_for_the_link_to_the_product_page;
  global $bs_Text_Order_Only_Via_The_Shop;
  if ( is_shop() || is_product_category() || is_product_tag() || is_product() )
	  {
    $free_label = '<span class="amount">'.$bs_Text_Order_Only_Via_The_Shop.'</span>';
    if( $product->is_type('variable') )
      {
      $price_min  = wc_get_price_to_display( $product, array( 'price' => $product->get_variation_price('min') ) );
      $price_max  = wc_get_price_to_display( $product, array( 'price' => $product->get_variation_price('max') ) );
      if( $price_min != $price_max )
  	    {
        if( $price_min == 0 && $price_max > 0 )
          $price = wc_price( $price_max );
        elseif( $price_min > 0 && $price_max == 0 )
          $price = wc_price( $price_min );
        else
          $price = wc_format_price_range( $price_min, $price_max );
        }
    	else
    	  {
        if( $price_min > 0 )
          $price = wc_price( $price_min);
        else
          $price = $free_label;
        }
      }
    elseif( $product->is_on_sale() )
      {
      $regular_price = wc_get_price_to_display( $product, array( 'price' => $product->get_regular_price() ) );
      $sale_price = wc_get_price_to_display( $product, array( 'price' => $product->get_sale_price() ) );
      if( $sale_price > 0 )
        $price = wc_format_sale_price( $regular_price, $sale_price );
      else
        $price = $free_label;
      }
    else
      {
      $active_price = wc_get_price_to_display( $product, array( 'price' => $product->get_price() ) );
      if( $active_price > 0 )
        $price = wc_price($active_price);
      else
        $price = $free_label;
      }
    }
  return $price.'<span class="amount"><br><a href="'.$bs_Location_of_the_product_page_on_the_WordPress_website.'&bs_sku='.$product->get_sku().'">'.$bs_Text_for_the_link_to_the_product_page.'</a></span>';
}

// Remove the out of stock text
add_filter( 'woocommerce_get_availability', 'change_out_of_stock_text', 1, 2);
function change_out_of_stock_text( $availability, $_product ) {
  global $post;
  if ( ! $_product->is_in_stock() )
	  {
    if(get_post_meta( $post->ID, '_text_field', true )!="")
      $out_of_stock = get_post_meta( $post->ID, '_text_field', true );
    $availability['availability'] = __('', 'woocommerce');
  }
  return $availability;
}

// create custom plugin settings menu
add_action('admin_menu', 'bs_create_menu');

function bs_create_menu() {
	//create new top-level menu
  add_menu_page( 
      'BakerySoftware', // Page Title 
      'BakerySoftware', // Menu name
      'administrator',
			__FILE__,
			'bs_plugin_settings_page' , // page_callback_function
      'https://bakerysoftware.com/wp_plugin/WP_Plugin_Logo.GIF' 
     );
	//call register settings function
	add_action( 'admin_init', 'register_my_cool_plugin_settings' );
}

function register_my_cool_plugin_settings() {
	register_setting( 'bs-plugin-settings-group', 'bs_telephone_id_code', [ 'default' => null ] );
	register_setting( 'bs-plugin-settings-group', 'bs_enlarge_bs_page_by_factor', [ 'default' => '1.4' ] );
	register_setting( 'bs-plugin-settings-group', 'bs_show_bs_header_and_footer', [ 'default' => '0' ] );
	register_setting( 'bs-plugin-settings-group', 'bs_show_the_nutritional_values_on_the_right', [ 'default' => '1' ] );
	register_setting( 'bs-plugin-settings-group', 'bs_show_a_photo_on_the_food_info_page', [ 'default' => '1' ] );
	register_setting( 'bs-plugin-settings-group', 'bs_use_http_and_not_https', [ 'default' => '0' ] );
	register_setting( 'bs-plugin-settings-group', 'bs_iframe_width', [ 'default' => '100%' ] );
	register_setting( 'bs-plugin-settings-group', 'bs_iframe_height', [ 'default' => '800' ] );
	register_setting( 'bs-plugin-settings-group', 'bs_iframe_border_thickness_px', [ 'default' => '1' ] );
	register_setting( 'bs-plugin-settings-group', 'bs_iframe_border_color', [ 'default' => '#004080' ] );
	register_setting( 'bs-plugin-settings-group', 'bs_iframe_border_style', [ 'default' => 'solid' ] );
	register_setting( 'bs-plugin-settings-group', 'bs_location_of_the_product_page', [ 'default' => null ] );
	register_setting( 'bs-plugin-settings-group', 'bs_text_for_the_link_to_the_product_page', [ 'default' => 'Allergens &amp; extra info' ] );
	register_setting( 'bs-plugin-settings-group', 'bs_text_order_only_via_the_shop', [ 'default' => 'Only via the shop' ] );
	register_setting( 'bs-plugin-settings-group', 'bs_csv_datetime_u', [ 'default' => '0' ] );
}

add_action( 'woocommerce_before_main_content', 'bs_Update_CSV', 1 );

function bs_Update_CSV()
  {
  global $CSV_File;
  global $log;
  $log = '';
  if (file_exists($CSV_File)) // Does the update file exist?
    {
  	if (get_option('bs_csv_datetime_u') != date ("U", filemtime($CSV_File))) // Is it new?
  	  {
  		update_option('bs_csv_datetime_u', date ("U", filemtime($CSV_File)));
  	  $log .= "$CSV_File was last modified: " . date ("F d Y H:i:s.", filemtime($CSV_File)).'<br /><br />';
      $a = -1;
      $csv = array();
      if (($handle = fopen($CSV_File, "r")) !== FALSE)
        {
        while (($data = fgetcsv($handle, 1000, ",")) !== FALSE)
      	  {
          $a++;
    			$csv[$a][0] = true;
          for ($b=1; $b <= count($data); $b++)
            $csv[$a][$b] = $data[$b-1];
          }
        fclose($handle);
        }
      $log .= "*** CSV table imported ****<br /><table>";
      for ($a=0; $a < count($csv); $a++)
        {
        $log .= "<tr>";
        for ($b=1; $b < count($csv[$a]); $b++)
    		  {
          $log .= "<td>".$csv[$a][$b].'</td>';
          }
        $log .= "</tr>";
        }
      $log .= "</table>";
    //var_dump($csv);
      $log .= '<br />';

      $Products_Create = array();
      $Products_Update = array();
      $Products_Delete = array();
      $args = 
        array(
          'limit' => -1,
          'orderby' => 'sku',
          'order' => 'ASC'
        );
      // Perform Query
      $query = new WC_Product_Query($args);
      // Collect Product Object
      $products = $query->get_products();
      for ($x = 0; $x < count($products); $x++)
        {
        $bs_wc_id = $products[$x]->get_id();
      	$bs_wc_sku = $products[$x]->get_sku();
      	$Update_Set = false;
        for ($a=1; $a < count($csv); $a++) // 0 are the titles
          {
          if (($csv[$a][0] == true) and ($csv[$a][2] == $bs_wc_sku))
      		  {
      			$b = count($Products_Update);
      			$csv[$a][0] = false;
      			$Products_Update[$b][0] = $a;
      			$Products_Update[$b][1] = $bs_wc_id;
          	$Update_Set = true;
      			break;
      			}
          }
      	if ($Update_Set == false)
    		  {
    			$Products_Delete[count($Products_Delete)] = $bs_wc_id;
    			}
        }
      for ($a=1; $a < count($csv); $a++) // 0 are the titles
        {
    		if ($csv[$a][0] == true)
    		  $Products_Create[count($Products_Create)] = $a; 
        }
      //var_dump($products[$x]. '<br /><br />');
    
      $log .= "*** Existing categories ****<br />";
    	$Categories = array();
    	global $Categories;
    	
      $cat_args = array('orderby' => 'name', 'order' => 'asc', 'hide_empty' => false);
      $product_categories = get_terms('product_cat', $cat_args);
    //var_dump($product_categories);
      if (count($product_categories) > 0)
        {
        for ($a=0; $a < count($product_categories); $a++)
          {
    			$log .= $product_categories[$a]->term_id.' '.$product_categories[$a]->name.' '.$product_categories[$a]->slug.'<br />';
    			$Categories[$a][0] = true;
    			$Categories[$a][1] = $product_categories[$a]->term_id;
    			$Categories[$a][2] = $product_categories[$a]->name;
    			$Categories[$a][3] = $product_categories[$a]->slug;
    			}
      	}
    
    function Find_Category_Id($name)
      {
    	global $Categories;
			global $log;
    	$Category_Found = false; 
      if (count($Categories) > 0)
        {
        for ($a=0; $a < count($Categories); $a++)
          {
    			if ($Categories[$a][2] == $name) // $product_categories[$a]->name
    			  {
    				$Categories[$a][0] = false;
    				$Category_Found = true;
    				$result = $Categories[$a][1];
    				break;
    				}
    			}
    		}		
    	if ($Category_Found == false)
    	  {
       // https://stackoverflow.com/questions/18107754/how-to-add-a-product-category-in-woocommerce-wordpress
    	  $log .= 'Added new category: '.$name.'<br />';
      
        wp_insert_term(
          $name, // the term 
          'product_cat', // the taxonomy
          array('description'=> $name, 'slug' => sanitize_title($name) ) );
        $cat_args = array('orderby' => 'name', 'order' => 'asc', 'hide_empty' => false);
        $product_categories = get_terms('product_cat', $cat_args);
        for ($a=0; $a < count($product_categories); $a++)
          {
    			if ($product_categories[$a]->name == $name) // $product_categories[$a]->name
    			  {
    				$Category_Found = true;
    				$Categories[$a][0] = false;
      			$Categories[$a][1] = $product_categories[$a]->term_id;
      			$Categories[$a][2] = $product_categories[$a]->name;
      			$Categories[$a][3] = $product_categories[$a]->slug;
    				$result = $Categories[$a][1];
    				break;
    				}
    			}
    		}
      return $result;
    }
    							
    $log .= '<br />';								
    	
    $log .= "*** Import log ****<br />";
    $log .= '<table>';
    	// https://woocommerce.github.io/code-reference/classes/WC-Product.html#method_delete
      if (count($Products_Create) > 0)
        {
        for ($a=0; $a < count($Products_Create); $a++)
          {
          $log .= '<tr><td>Create</td><td>'.$a.'</td><td>'.$csv[$Products_Create[$a]][2].'</td><td>'.$csv[$Products_Create[$a]][3].'</td></tr>';
          //$product = new WC_Product();
          $product = new WC_Product_Simple();
          // type
          $product->set_sku($csv[$Products_Create[$a]][2]);
          $product->set_name($csv[$Products_Create[$a]][3]);
          if ($csv[$Products_Create[$a]][4] == 1)
           $product->set_status('publish');
          else	
           $product->set_status('private');
          $product->set_short_description($csv[$Products_Create[$a]][5]);
          $product->set_description($csv[$Products_Create[$a]][6]); 
          if ($csv[$Products_Create[$a]][7] == 1)
           $product->set_stock_status('instock');
          else	
           $product->set_stock_status('outofstock');
          $product->set_regular_price($csv[$Products_Create[$a]][8]);   
          $product->set_category_ids(array(Find_Category_Id($csv[$Products_Create[$a]][9])));
          $product->save(); // Store changes in database
    			// Image
          if (strlen($csv[$Products_Create[$a]][10]) > 0)
            {
            $image_url = wc_rest_upload_image_from_url($csv[$Products_Create[$a]][10]);
            $image_id = wc_rest_set_uploaded_image_as_attachment($image_url, $product->get_id());
            $product->set_image_id($image_id);
            $product->save();			
            }	
          }
      	}	
      if (count($Products_Update) > 0)
        {
        for ($a=0; $a < count($Products_Update); $a++)
          {
          $log .= '<tr><td>Update</td><td>'.$a.'</td><td>'.$csv[$Products_Update[$a][0]][2].'</td><td>'.$csv[$Products_Update[$a][0]][3].'</td></tr>';
          $product    = wc_get_product($Products_Update[$a][1]);
          
          // type
          $product->set_sku($csv[$Products_Update[$a][0]][2]);
          $product->set_name($csv[$Products_Update[$a][0]][3]);
          if ($csv[$Products_Update[$a][0]][4] == 1)
           $product->set_status('publish');
          else	
           $product->set_status('private');
          $product->set_short_description($csv[$Products_Update[$a][0]][5]);
          $product->set_description($csv[$Products_Update[$a][0]][6]); 
          if ($csv[$Products_Update[$a][0]][7] == 1)
           $product->set_stock_status('instock');
          else	
           $product->set_stock_status('outofstock');
          $product->set_regular_price($csv[$Products_Update[$a][0]][8]);   
          $product->set_category_ids(array(Find_Category_Id($csv[$Products_Update[$a][0]][9])));
          $product->save(); // Store changes in database
    			// Image
          if (($product->get_image_id() == null) and (strlen($csv[$Products_Update[$a][0]][10]) > 0))
            {
            $image_url = wc_rest_upload_image_from_url($csv[$Products_Update[$a][0]][10]);
            $image_id = wc_rest_set_uploaded_image_as_attachment($image_url, $product->get_id());
            $product->set_image_id($image_id);
						$product->save();
            }	
          }
      	}	
    		
      if (count($Products_Delete) > 0)
        {
        for ($a=0; $a < count($Products_Delete); $a++)
          {
          $product = wc_get_product($Products_Delete[$a]);
          $log .= '<tr><td>Delete</td><td>'.$a.'</td><td>'.$product->sku.'</td><td>'.$product->name.'</td></tr>';
     		  $product->delete(true);
          }
      	}	
      } 
    $log .= '</table>';
    
    /* this does not work !
    if (count($Categories) > 0)
      {
      for ($a=0; $a < count($Categories); $a++)
        {
    	  if ($Categories[$a][0] == true)
    	    {
    			$log .= '<br />Category '.$Categories[$a][1].' - '.$Categories[$a][2];
    			$categ_ID = $Categories[$a][1]; 
    			if (wp_delete_category($categ_ID))
    		    print('<br />Category '.$Categories[$a][1].' - '.$Categories[$a][2].' was successfully deleted'); 
          else
    			  print('<br />Category '.$Categories[$a][1].' - '.$Categories[$a][2].' could not be deleted. Make sure it exists and that it is not the default category');
    	    }
    	  }
      }
    */
    
  }  
	return $log;
}

function bs_plugin_settings_page() {
  global $log;
  bs_Update_CSV();
?>
<div class="wrap">
<h1>BakerySoftware</h1>

<p>
Bakers who use the <a href="https://bakerysoftware.com/">BakerySoftware.com</a> software can use this plug-in to create a WordPress with WooCommerce website. Usage of this plug-in is free. This plug-in requires the WooCommerce plug-in to be installed and activated.
</p><p>
The technology used is based on the html "iframe" element. This is for food safety reasons. Suppliers of raw materials often change the ingredients, and this in turn directly affects the ingredient and allergy declarations of the baker. Perfect solutions are not possible, but outdated info that is not updated for many years on a WordPress website is not acceptable. So the "iframe" is the only option.
</p><p>
Products that in the BakerySoftware.com software have price zero or less, will have their stock amount set to zero. So they cannot be ordered and instead of the price the text "Only via the shop" (you can change this text in the forth option field) will be shown.
</p><p>
The main reason for a bakery to have a website is to inform their customers about the allergens and ingredients in their products. Bakers also want to show their bakery shop and products on the web. Adding a webshop to this website is a logical step, but please be aware that the logic of a webshop and that of a bakery are very different. A bakery is very dynamic in nature and almost all products can be modified at the request of the customer, while a webshop is designed for selling fixed products from existing stock with precise stock management. So it is best to make a clear distinction between those products that can be ordered online, and those that cannot. And explain to the customer that you are an artisanal producer and that your best products can only be ordered via phone.
</p><p>
Usage in WordPress:
</p><p>
From the WordPress root go to /wp-content/plugins/ and create the directory "bakery_software". Place the file "bakery_software.php" in this directory. Then in the WordPress "Dashboard" activate the bakery software plug-in.
</p><p>
Make an allergy page and add the shortcode [BakerySoftware bs_page_name="allergy"]. Make a product page and add the shortcode [BakerySoftware bs_page_name="product"], and put the location of this page in the second option field "Location of the product info page". Other options for bs_page_name are: "index", "assortment", "info". Normally when you call the product page, the SKU number will be in the URL. But, if not, you must add the "bs_sku=" option to the shortcode.
</p><p>
Fill in the international telephone dialling code of the bakery without the "+" in the first option field. You can also see this code in the URL of your free website at https://bakerysoftware.com/, just after the ".com/" bit.
</p><p>
An image is only updated if there is not one at the present. So, manually installed images will not be overwritten. But also, for updating an existing image with a new one from our software, the old one will first have to be deleted in WordPress.
</p><p>
Our software updates the WordPress website by sending a file named "WooCommerce.csv" via FTP. Copy and paste the following FTP destination:<br>&nbsp;&nbsp;
<?php 
global $CSV_File;
print('<b>'.WP_PLUGIN_DIR.'/bakery_software/</b>');
?>
<br>into our software. Make sure you also check the box to automatically update the WordPress website, and also that you enter the correct settings for making the FTP connection. Note that you might need to refresh a webpage, or change to another, twice to see the update if it has just come in.
</p>
<br>
<form method="post" action="options.php">
    <?php settings_fields( 'bs-plugin-settings-group' ); ?>
    <?php do_settings_sections( 'bs-plugin-settings-group' ); ?>
    <table class="form-table">

        <tr valign="top">
        <th scope="row" nowrap>The international telephone dialling code of the bakery without the "+"</th>
        <td><input type="text" name="bs_telephone_id_code" value="<?php echo esc_attr( get_option('bs_telephone_id_code') ); ?>" /></td>
        </tr>
		
        <tr valign="top">
        <th scope="row" nowrap>Location of the product info page (for example: "/?page_id=2")</th>
        <td><input type="text" name="bs_location_of_the_product_page" value="<?php echo esc_attr( get_option('bs_location_of_the_product_page') ); ?>" /></td>
        </tr>
         
        <tr valign="top">
        <th scope="row" nowrap>Text for the link to the info product page (something like: "Allergens &amp; extra info")</th>
        <td><input type="text" name="bs_text_for_the_link_to_the_product_page" value="<?php echo esc_attr( get_option('bs_text_for_the_link_to_the_product_page') ); ?>" /></td>
        </tr>
        
        <tr valign="top">
        <th scope="row" nowrap>Text "order only via the shop" (something like: "Only via the shop")</th>
        <td><input type="text" name="bs_text_order_only_via_the_shop" value="<?php echo esc_attr( get_option('bs_text_order_only_via_the_shop') ); ?>" /></td>
        </tr>
         
        <tr valign="top">
        <th scope="row" nowrap>Enlarge my website at BakerySoftware by a factor of:</th>
        <td><input type="range" min="0.5" max="2" step="0.1" name="bs_enlarge_bs_page_by_factor" value="<?php echo esc_attr( get_option('bs_enlarge_bs_page_by_factor') ); ?>" /></td>
        </tr>

        <tr valign="top">
        <th scope="row" nowrap>Show the nutritional values on the right on the food info page</th>
        <td><input type="checkbox" name="bs_show_the_nutritional_values_on_the_right" value="1" <?php checked( 1, get_option( 'bs_show_the_nutritional_values_on_the_right' ) ); ?> /></td>
        </tr>
         
        <tr valign="top">
        <th scope="row" nowrap>Show a photo on the food info page</th>
        <td><input type="checkbox" name="bs_show_a_photo_on_the_food_info_page" value="1" <?php checked( 1, get_option( 'bs_show_a_photo_on_the_food_info_page' ) ); ?> /></td>
        </tr>

        <tr valign="top">
        <th scope="row" nowrap>Check this box if your website's URL starts with "http://", rather than "https://"</th>
        <td><input type="checkbox" name="bs_use_http_and_not_https" value="1" <?php checked( 1, get_option( 'bs_use_http_and_not_https' ) ); ?> /></td>
        </tr>
         
        <tr valign="top">
        <th scope="row" nowrap>Also show the header and footer of my website at BakerySoftware</th>
        <td><input type="checkbox" name="bs_show_bs_header_and_footer" value="1" <?php checked( 1, get_option( 'bs_show_bs_header_and_footer' ) ); ?> /></td>
        </tr>
         
        <tr valign="top">
        <th scope="row" nowrap>iframe - width</th>
        <td><input type="text" name="bs_iframe_width" value="<?php echo esc_attr( get_option('bs_iframe_width') ); ?>" /></td>
        </tr>
         
        <tr valign="top">
        <th scope="row" nowrap>iframe - height</th>
        <td><input type="text" name="bs_iframe_height" value="<?php echo esc_attr( get_option('bs_iframe_height') ); ?>" /></td>
        </tr>
         
        <tr valign="top">
        <th scope="row" nowrap>iframe - border - thickness in pixels</th>
        <td><input type="number" name="bs_iframe_border_thickness_px" value="<?php echo esc_attr( get_option('bs_iframe_border_thickness_px') ); ?>" /></td>
        </tr>
         
        <tr valign="top">
        <th scope="row" nowrap>iframe - border - colour</th>
        <td><input type="color" name="bs_iframe_border_color" value="<?php echo esc_attr( get_option('bs_iframe_border_color') ); ?>" /></td>
        </tr>
         
        <tr valign="top">
        <th scope="row" nowrap>iframe - border - style</th>
        <td><input type="text" name="bs_iframe_border_style" value="<?php echo esc_attr( get_option('bs_iframe_border_style') ); ?>" /></td>
        </tr>

    </table>
    <?php submit_button(); ?>
</form>
</div>

<br><br>

<p>
<b>Automatic updates log:</b><br>
<?php 
	if (file_exists($CSV_File))
	  {
  	print('A file with the name "<b>WooCommerce.csv</b>" does exist at: '.'<b>'.WP_PLUGIN_DIR.'/bakery_software/</b>'.' and its file date is: '.date ("F d Y H:i:s", filemtime($CSV_File)).'. ');
  	if (get_option('bs_csv_datetime_u') == date ("U", filemtime($CSV_File))) // Is it new?
  	  print('Which is equal to the last successful update preformed at: '.date ("F d Y H:i:s", get_option('bs_csv_datetime_u')).', so updates seem to be working well.<br /><br />');
		else	
		  print('<b>But this date time is NOT equal to the last successful update preformed at: '.date ("F d Y H:i:s", get_option('bs_csv_datetime_u')).', so there is a problem</b><br /><br />'.$log);
		}
  else
	  print('<b>A file with the name "<b>WooCommerce.csv</b>" does NOT exist at: '.'<b>'.WP_PLUGIN_DIR.'/bakery_software/</b>'.' , so there is a problem.</b><br /><br />'.$log);
print('</p>');
}
?>





